//NINA_Graph_404d.js
//Eine Weiterentwicklung des Scripts "NINA.jsx" von Olav Martin Kvern
// 12.04.12 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//DESCRIPTION:Zeichnet ein dekoratives geometrisches Objekt

//For more on NINA, see http://www.washington.edu/bibsys/mattf/nina/index.html

// vorsichtshalber die Dialoge einschalten
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// die Version speichern
var appVers = (app.version[0])*1;

// die Namen der fixen Farbfelder definieren
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";

// die Sprache de Programms speichern
var curLang = (app.locale)*1;

// die Namen der Farbfelder vorbereiten (in FR and DE)
if (curLang   == 1279477362) { // = Franzsisch
	noColor      = "[Sans]";
	regisColor   = "[Registration]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
		regisColor = "[Registration]";
	}
}
else if (curLang == 1279477613) { // = Deutsch
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
}

// der Haupt-Teil des Scripts
if (app.documents.length != 0) {
	if (app.activeWindow.constructor.name == "LayoutWindow") {
		var curDoc = app.documents[0];
		// die Farbfelder auflisten
		allSwatches = curDoc.swatches;
		// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
		var allPrefs = getPrefs();
		if (allPrefs != "") {
			var prefVal = allPrefs.split("\n");
			var xPos  = prefVal[0]*1;
			var yPos  = prefVal[1]*1;
			var curD  = prefVal[2]*1;
			var nPts  = prefVal[3]*1;
			var aPls  = prefVal[4]*1;
			var bPls  = prefVal[5]*1;
			var bName = prefVal[6];
			if      (bName == "Black") { bName = blackColor; }
			else if (bName == "Paper") { bName = paperColor; }
			else if (bName == "Registration") { bName = regisColor; }
			else if (bName == "None") { bName = noColor; }
			var bgrT  = prefVal[7]*1;
			var ck0   = false;
			var eoFll = prefVal[8];
			if (eoFll == "true") {
				ck0 = true;
			}
			var sName = prefVal[9];
			if      (sName == "Black") { sName = blackColor; }
			else if (sName == "Paper") { sName = paperColor; }
			else if (sName == "Registration") { sName = regisColor; }
			else if (sName == "None") { sName = noColor; }
			var strT  = prefVal[10]*1;
			var strW  = prefVal[11]*1;
			var alig  = prefVal[12];
			var ck1 = 1;
			var ck2 = 0;
			var ck3 = 0;
			if (alig == "1") {
				ck1 = 0;
				ck2 = 1;
			}
			else if (alig == "2") {
				ck1 = 0;
				ck3 = 1;
			}
		}
		else {
			// wenn die Prferenzen-Datei nicht gefunden wurde
			// dann auf die Vorgabenwerte zurckgreifen
			var xPos =   100;
			var yPos =   100;
			var curD =    50;
			var nPts =   201;
			var aPls =    16;
			var bPls =   161;
			var bgrT =    70;
			var ck0  = false;
			var strT =   100;
			var strW =   0.5;
			var ck1  =     1;
			var ck2  =     0;
			var ck3  =     0;
			var bName = noColor;
			var sName = blackColor;
		}
		
		// die Funktionen aufrufen, welche die Listen der Farben vorbereiten
		var bgrColor = getBgrColorList(bName);
		var bgrCol   = bgrColor[0];
		var bInd     = bgrColor[1];
		var strColor = getStrColorList(sName);
		var strCol   = strColor[0];
		var sInd     = strColor[1];
		
		// die Masseinheiten speichern
		// wenn nicht 2053991795 (= Millimeter), dann auf Millimeter umstellen
		hM = curDoc.viewPreferences.horizontalMeasurementUnits;
		vM = curDoc.viewPreferences.verticalMeasurementUnits;
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
		}
		// den Linealursprung auf "Seite" setzen
		var rO = curDoc.viewPreferences.rulerOrigin;
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = RulerOrigin.pageOrigin;
		}
		
		// den Nullpunkt auf Null/Null setzen
		var zP = curDoc.zeroPoint; 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = [0,0]; 
		}
		
		// die Funktion aufrufen, welche den Dialog zeigt und auswertet
		var anArray = displayDialog(xPos, yPos, curD, nPts, aPls, bPls, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3);
		var centerPoint = anArray[0];
		var xPos        = centerPoint[0];
		var yPos        = centerPoint[1];
		var curDiameter = anArray[1];
		var numOfLines  = anArray[2];
		var aPulse      = anArray[3];
		var bPulse      = anArray[4];
		var bColor      = anArray[5];
		var bgrT        = anArray[6];
		var evenOddFill = anArray[7];
		var sColor      = anArray[8];
		var strT        = anArray[9];
		var strW        = anArray[10];
		var strA        = anArray[11];
		// die Funktion aufrufen, welche die NINA zeichnet
		drawNINA(xPos, yPos, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, evenOddFill, sColor, strT, strW, strA);
		
		// den Nullpunkt zurcksetzen (falls notwendig) 
		if (zP != [0,0]) { 
			curDoc.zeroPoint = zP; 
		}
		
		// den Linealursprung zurcksetzen  (falls notwendig)
		if (rO != 1380143215) {
			curDoc.viewPreferences.rulerOrigin = rO;
		}

		// Masseinheiten zurcksetzen (falls notwendig)
		if (hM != 2053991795) {
			curDoc.viewPreferences.horizontalMeasurementUnits = hM;
		}
		if (vM != 2053991795) {
			curDoc.viewPreferences.verticalMeasurementUnits = vM;
		}
		// den Bildschirm-Modus auf "Vorschau" setzen
		if (appVers > 4) {
			app.activeWindow.screenMode = ScreenModeOptions.PREVIEW_TO_PAGE;
		}
	}
}
else {
	alert ("Bitte ein Dokument ffnen.", "Stop");
}


///////////// DIE FUNKTIONEN ///////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGraph404.txt");
	}
	else {
		var f = new File("~/Library/Preferences/NinaGraph404.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// die Funktion, welche die Liste der Hintergrund-Farben vorbereitet
function getBgrColorList(bName) {	
	// prfen, ob die Vorgabefarbe existiert
	if (bName != noColor && bName != regisColor && bName != paperColor && bName != blackColor) {
		try {
			curDoc.swatches.itemByName(bName).name;
		}
		catch (e) {
			bName = blackColor;
		}
	}
	
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var bgrColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (bName == cName) {
			bIndex = i;
		}
		bgrColorList.push(cName);
	}
	return [bgrColorList, bIndex];
}

// die Funktion, welche die Liste der Kontur-Farben vorbereitet
function getStrColorList(sName) {
	// prfen, ob die Vorgabefarbe existiert
	if (sName != noColor && sName != regisColor && sName != paperColor && sName != blackColor) {
		try {
			curDoc.swatches.itemByName(sName).name;
		}
		catch (e) {
			sName = blackColor;
		}
	}
	
	// die Liste der Farben zusammenstellen;
	// "None",  "Registration", "Paper" und "Black" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var strColorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (sName == cName) {
			sIndex = i;
		}
		strColorList.push(cName);
	}
	return [strColorList, sIndex];
}

// den Dialog vorbereiten und anzeigen
function displayDialog(xPos, yPos, curD, nPts, aPls, bPls, bgrCol, bInd, bgrT, ck0, strCol, sInd, strT, strW, ck1, ck2, ck3) {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 70;
	var fieldWidth = 40;
	var aDialog = app.dialogs.add({name:"NINA_Graph"});
	with (aDialog.dialogColumns.add()) {
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Zentrum", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"X:"});
			}
			with (dialogColumns.add()) {
				var xField = realEditboxes.add({editValue:xPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Y:"});
			}
			with (dialogColumns.add()) {
				var yField = realEditboxes.add({editValue:yPos, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		labelWidth = 95;
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Linienlnge", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var curDiameterField = realEditboxes.add({editValue:curD, minWidth:fieldWidth});
			}
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"mm"});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Anzahl Punkte", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var nPointsField = integerEditboxes.add({editValue:nPts, minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Schwingung A", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var APulseField = integerEditboxes.add({editValue:aPls,minWidth:fieldWidth});
			}
		}
		with (dialogRows.add()) {
			with (dialogColumns.add()) {
				staticTexts.add({staticLabel:"Schwingung B", minWidth:labelWidth});
			}
			with (dialogColumns.add()) {
				var BPulseField = integerEditboxes.add({editValue:bPls, minWidth:fieldWidth});
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"HINTERGRUND", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var bgrColor = dropdowns.add({stringList:bgrCol, selectedIndex:bInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Tonwert", minWidth:labelWidth-10});
					var bgrTint = realEditboxes.add({editValue:bgrT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
			}
		}
		var evenOddCheckbox = checkboxControls.add({staticLabel:"Abwechselnd fllen", checkedState:ck0});
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"KONTUR", minWidth:labelWidth-10});
					staticTexts.add({staticLabel:" "});
				}
				var strColor = dropdowns.add({stringList:strCol, selectedIndex:sInd, minWidth:130});
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Tonwert", minWidth:labelWidth-10});
					var strTint = realEditboxes.add({editValue:strT, minimumValue:0, maximumValue:100, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"%", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Konturstrke", minWidth:labelWidth-10});
					var strWeight = realEditboxes.add({editValue:strW, minimumValue:0, maximumValue:5, minWidth:fieldWidth});
					staticTexts.add({staticLabel:"pt", minWidth:12});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ausrichtung", minWidth:labelWidth-10});
					with(aligButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"mittig", checkedState:ck1});
						radiobuttonControls.add({staticLabel:"innen", checkedState:ck2});
						radiobuttonControls.add({staticLabel:"aussen", checkedState:ck3});
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		var x = xField.editValue;
		var y = yField.editValue;
		var curDiameter = curDiameterField.editValue;
		var numOfLines  = nPointsField.editValue;
		var aPulse = APulseField.editValue;
		var bPulse = BPulseField.editValue;
		bgrIndex = bgrColor.selectedIndex;
		bColor = curDoc.swatches[bgrIndex].name;
		if      (bColor == blackColor) { bColor = "Black"; }
		else if (bColor == paperColor) { bColor = "Paper"; }
		else if (bColor == regisColor) { bColor = "Registration"; }
		else if (bColor == noColor)    { bColor = "None"; }
		bgrT = bgrTint.editValue;
		var ck0 = evenOddCheckbox.checkedState;
		strIndex = strColor.selectedIndex;
		sColor = curDoc.swatches[strIndex].name;
		if      (sColor == blackColor) { sColor = "Black"; }
		else if (sColor == paperColor) { sColor = "Paper"; }
		else if (sColor == regisColor) { sColor = "Registration"; }
		else if (sColor == noColor)    { sColor = "None"; }
		strT = strTint.editValue;
		strW = strWeight.editValue;
		var aligDec = aligButtons.selectedButton;
		if (aligDec == 0) {
			strA = 1936998723; // mittig
		}
		else if (aligDec == 1) {
			strA = 1936998729; // innen
		}
		else if (aligDec == 2) {
			strA = 1936998735; // aussen
		}
		aDialog.destroy();
		var prefsList = new Array (x, y, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, aligDec);
		var prefString = prefsList.join("\n");
		writeResult(prefString);
		if (ck0 == true && numOfLines%2 == 0) {
			alert ("Die Anzahl Punkte muss ungerade sein, damit abwechselnd gefllt werden kann.", "Achtung");
			exit();
		}
		return [[x, y], curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, strA];
	}
	else{
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben
function writeResult(curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/NinaGraph404.txt");
	}
	else {
		var f = File("~/Library/Preferences/NinaGraph404.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// diese Funktion zeichnet die NINA
function drawNINA(xPos, yPos, curDiameter, numOfLines, aPulse, bPulse, bColor, bgrT, ck0, sColor, strT, strW, strA) {
	var cur_x, cur_y;
	var aAnchor = new Array(2);
	var arr = new Array(numOfLines);
	// statt den Pfad Punkt fr Punkt zu zeichnen, wird der Array "arr" mit einer Reihe 
	// von Koordinaten gefllt und alle Punktpositionen werden aufs Mal mit "entirePath" zugewiesen;
	for (var ctr = 0; ctr < numOfLines; ctr++) {
		cur_x = ((Math.cos((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.cos((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + xPos;
		cur_y = ((Math.sin((-2 * Math.PI * aPulse * ctr) / numOfLines) + Math.sin((-2 * Math.PI * bPulse * ctr) / numOfLines)) * curDiameter) + yPos;
		aAnchor = [cur_x, cur_y];
		arr[ctr] = aAnchor;
	}
	with (curDoc){
		var curPage = app.activeWindow.activePage;
		var isLocked = false;
		var curLayer = app.activeWindow.activeLayer;
		if (curLayer.locked == true) {
			curLayer.locked = false;
			var isLocked = true;
		}
		with (curPage) {
			var newLine = graphicLines.add();
			newLine.strokeWeight = strW;
			var curPath = newLine.paths.item(0);
			// jetzt dem Pfad den Inhalt des Arrays zuweisen
			curPath.entirePath = arr;
			curPath.pathType = PathType.closedPath;
			// die Farben zuweisen
			if (ck0 == true) {
				var newPolygon = newLine.duplicate();
				try {
					newLine.addPath(newPolygon);
				}
				catch (e) {
				}
				newPolygon.properties = {fillColor:bColor, fillTint:bgrT, strokeWeight:strW, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
				// die NINA-Einstellungen in das Objekt-Label setzen
				newPolygon.label = "Linienlnge: " + curDiameter + " mm\rAnzahl Punkte: " + numOfLines + "\rSchwingung A: " + aPulse + "\rSchwingung B: " + bPulse;
			}
			else {
				newLine.properties = {fillColor:bColor, fillTint:bgrT, strokeColor:sColor, strokeTint:strT, strokeAlignment:strA};
				// die NINA-Einstellungen in das Objekt-Label setzen
				newLine.label = "Linienlnge: " + curDiameter + " mm\rAnzahl Punkte: " + numOfLines + "\rSchwingung A: " + aPulse + "\rSchwingung B: " + bPulse;
			}
		}
		if (isLocked) {
			curLayer.locked = true;
		}
	}
}